blob: 00dd64eb688682916e4ab56941bf3c0c1c0d803e [file] [log] [blame]
#!/bin/bash
################################################################################
# Copyright (C) 2024 OpenInfra Foundation Europe. All rights reserved. #
# #
# Licensed under the Apache License, Version 2.0 (the "License"); #
# you may not use this file except in compliance with the License. #
# You may obtain a copy of the License at #
# #
# http://www.apache.org/licenses/LICENSE-2.0 #
# #
# Unless required by applicable law or agreed to in writing, software #
# distributed under the License is distributed on an "AS IS" BASIS, #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. #
# See the License for the specific language governing permissions and #
# limitations under the License. #
################################################################################
ROOT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null && pwd )"
#Check for helm3
IS_HELM3=$(helm version -c --short|grep -e "^v3")
CM_VERSION="v0.16.2"
CM_PORT="8879"
CM_BASE_URL="http://127.0.0.1:$CM_PORT"
CM_CHART_GET_URL="$CM_BASE_URL/charts"
CM_CHART_POST_URL="$CM_BASE_URL/charts/api/charts"
if ! command -v chartmuseum &> /dev/null
then
pushd /tmp
echo "Installing ChartMuseum binary..."
wget https://get.helm.sh/chartmuseum-$CM_VERSION-linux-amd64.tar.gz
tar xvfz chartmuseum-$CM_VERSION-linux-amd64.tar.gz
sudo mv /tmp/linux-amd64/chartmuseum /usr/local/bin/chartmuseum
popd
else
echo "ChartMuseum is already installed."
fi
# Package common templates and serve it using Helm local repo
HELM_LOCAL_REPO="./chartstorage"
rm $HELM_LOCAL_REPO/*
#Start Chart Museum server if there isn't one
CHART_MUSEUM_PID=$(lsof -i :"$CM_PORT" | grep "chartmus" | grep -v "grep" | awk '{print $2}')
if [ -z "$CHART_MUSEUM_PID" ]; then
echo "Starting ChartMuseum on port $CM_PORT..."
nohup chartmuseum --port=$CM_PORT --storage="local" --context-path=/charts --storage-local-rootdir=$HELM_LOCAL_REPO >/dev/null 2>&1 &
echo $! > $ROOT_DIR/CM_PID.txt
else
echo "ChartMuseum is already running..."
fi
# Check if ChartMuseum is ready to serve request
command="curl --silent --output /dev/null $CM_BASE_URL"
for i in $(seq 1 5)
do $command && s=0 && break || s=$? && echo "Failed to establish a connection with the ChartMuseum server. Retrying after 5s" && sleep 5;
done
if [ $s -gt 0 ]
then
echo "Cmd to test ChartMuseum failed with ($s): $command"
exit $s
fi
helm repo remove local
helm repo add local $CM_CHART_GET_URL
echo -e "\nPackaging NONRTRIC common [nonrtric-common]"
NONRTRIC_COMMON_CHART_VERSION=$(cat $ROOT_DIR/../ric-common/Common-Template/helm/nonrtric-common/Chart.yaml | grep version | awk '{print $2}')
helm package -d /tmp $ROOT_DIR/../ric-common/Common-Template/helm/nonrtric-common
curl --data-binary @/tmp/nonrtric-common-$NONRTRIC_COMMON_CHART_VERSION.tgz $CM_CHART_POST_URL